// This Test Port skeleton source file was generated by the
// TTCN-3 Compiler of the TTCN-3 Test Executor version CRL 113 200/5 R3A
// for U-ERICSSON\ethgry (ethgry@HU00078339) on Fri Aug 14 21:19:06 2015

// Copyright Ericsson Telecom AB 2000-2014

// You may modify this file. Complete the body of empty functions and
// add your member functions here.

#include "BtpPort.hh"
#include "btp_layer_factory.hh"
#include "loggers.hh"

namespace LibItsBtp__TestSystem {

  BtpPort::BtpPort(const char *par_port_name)
    : BtpPort_BASE(par_port_name), _cfg_params(), _layer_params(), _layer(NULL), _time_key("BtpPort::outgoing_send") {}

  BtpPort::~BtpPort() {
    if (_layer != NULL) {
      delete _layer;
    }
  }

  void BtpPort::set_parameter(const char *parameter_name, const char *parameter_value) {
    loggers::get_instance().log("BtpPort::set_parameter: %s=%s", parameter_name, parameter_value);
    _cfg_params.insert(std::pair<std::string, std::string>(std::string(parameter_name), std::string(parameter_value)));
  }

  /*void BtpPort::Handle_Fd_Event(int fd, boolean is_readable,
    boolean is_writable, boolean is_error) {}*/

  void BtpPort::Handle_Fd_Event_Error(int /*fd*/) {}

  void BtpPort::Handle_Fd_Event_Writable(int /*fd*/) {}

  void BtpPort::Handle_Fd_Event_Readable(int /*fd*/) {}

  /*void BtpPort::Handle_Timeout(double time_since_last_call) {}*/

  void BtpPort::user_map(const char *system_port) {
    loggers::get_instance().log(">>> BtpPort::user_map: %s", system_port);
    // Build layer stack
    params_its::iterator it = _cfg_params.find(std::string("params"));
    if (it != _cfg_params.end()) {
      loggers::get_instance().log("BtpPort::user_map: %s", it->second.c_str());
      // Setup parameters
      params_its::convert(_layer_params, it->second); // TODO This _layer_params seems to be useless
      // Create layer
      _layer = layer_stack_builder::get_instance()->create_layer_stack(it->second.c_str());
      if (static_cast<btp_layer *>(_layer) == NULL) {
        loggers::get_instance().error("BtpPort::user_map: Invalid stack configuration: %s", it->second.c_str());
      }
      static_cast<btp_layer *>(_layer)->add_upper_port(this);
    } else {
      loggers::get_instance().error("BtpPort::user_map: No layers defined in configuration file");
    }
  }

  void BtpPort::user_unmap(const char *system_port) {
    loggers::get_instance().log(">>> BtpPort::user_unmap: %s", system_port);
    if (_layer != NULL) {
      delete _layer;
      _layer = NULL;
    }
  }

  void BtpPort::user_start() {}

  void BtpPort::user_stop() {}

  void BtpPort::outgoing_send(const LibItsBtp__TypesAndValues::BtpReq &send_par) {
    //    loggers::get_instance().log_msg(">>> BtpPort::outgoing_send: payload=", send_par);

    float duration;
    loggers::get_instance().set_start_time(_time_key);
    static_cast<btp_layer *>(_layer)->sendMsg(send_par, _layer_params);
    loggers::get_instance().set_stop_time(_time_key, duration);
  }

  void BtpPort::receiveMsg(const LibItsBtp__TypesAndValues::BtpInd& p_ind, const params& p_params) {
    //    loggers::get_instance().log_msg(">>> BtpPort::receive_msg: ", p_ind);
    const params_its& p = static_cast<const params_its&>(p_params);
    loggers::get_instance().log(">>> BtpPort::receive_msg: %s", p.btp_destination_port.c_str());

    incoming_message(p_ind);
  }

} // namespace LibItsBtp__TestSystem
