#include "lte_tcp_layer.hh"

#include "loggers.hh"

lte_tcp_layer::lte_tcp_layer(const std::string &p_type, const std::string &p_param): tcp_layer(p_type, p_param), data_event_observer() { 
  loggers::get_instance().log(">>> lte_tcp_layer::lte_tcp_layer (1)");

}

lte_tcp_layer::lte_tcp_layer(const std::string &p_type, const params_its &p_param): tcp_layer(p_type, p_param), data_event_observer() { 
  loggers::get_instance().log(">>> lte_tcp_layer::lte_tcp_layer (2)");
  
}

void lte_tcp_layer::receive_data(OCTETSTRING& p_data, params& p_params) {
  loggers::get_instance().log_msg(">>> lte_tcp_layer::receive_data: ", p_data);

  const params_its& params = static_cast<const params_its&>(p_params);
    loggers::get_instance().log(">>> lte_tcp_layer::receive_msg: %s", params.uu_protocol.c_str());

  if (_observers.size() != 0) {
    incoming_packet_notify(p_data, (params_its&)params);
  } else {
    // Pass the packet to the upper layers
    receive_to_all_layers(p_data, (params_its&)params);
  }
}

