/*!
 * \file      param_sits.cc
 * \brief     Source file for the parameter dictionary.
 * \author    ETSI STF525
 * \copyright ETSI Copyright Notification
 *            No part may be reproduced except as authorized by written permission.
 *            The copyright and the foregoing restriction extend to reproduction in all media.
 *            All rights reserved.
 * \version   0.1
 */
#include <regex>
#include <stdexcept>

#include "loggers.hh"
#include "params_its.hh"

const std::string& params_its::beaconing            = std::string("beaconing");
const std::string& params_its::station_type         = std::string("station_type");
const std::string& params_its::country              = std::string("country");
const std::string& params_its::type_of_address      = std::string("type_of_address");
const std::string& params_its::its_aid              = std::string("its_aid");
const std::string& params_its::ssp                  = std::string("ssp");
const std::string& params_its::gn_payload           = std::string("gn_payload");
const std::string& params_its::gn_next_header       = std::string("gnNextHeader");
const std::string& params_its::gn_header_type       = std::string("gnHeaderType");
const std::string& params_its::gn_header_sub_type   = std::string("gnHeaderSubtype");
const std::string& params_its::gn_lifetime          = std::string("gnLifetime");
const std::string& params_its::gn_traffic_class     = std::string("gnTrafficClass");
const std::string& params_its::btp_type             = std::string("btp_type");
const std::string& params_its::btp_payload          = std::string("btp_payload");
const std::string& params_its::btp_destination_port = std::string("dst_port");
const std::string& params_its::btp_info             = std::string("btp_info");

const std::string& params_its::latitude   = std::string("latitude");
const std::string& params_its::longitude  = std::string("longitude");
const std::string& params_its::ll_address = std::string("ll_address");
const std::string& params_its::expiry     = std::string("expiry");

const std::string& params_its::station_id = std::string("station_id");

const std::string& params_its::device_mode            = std::string("device_mode");
const std::string& params_its::secured_mode           = std::string("secured_mode");
const std::string& params_its::encrypted_mode         = std::string("encrypted_mode");
const std::string& params_its::enable_security_checks = std::string("enable_security_checks");
const std::string& params_its::force_certificate      = std::string("force_certificate");
const std::string& params_its::certificate            = std::string("certificate");
const std::string& params_its::peer_certificate       = std::string("peer_certificate");
const std::string& params_its::sec_db_path            = std::string("sec_db_path");
const std::string& params_its::hash                   = std::string("hash");
const std::string& params_its::signature              = std::string("signature");
const std::string& params_its::cypher                 = std::string("cypher");
const std::string& params_its::distanceA              = std::string("distanceA");
const std::string& params_its::distanceB              = std::string("distanceB");
const std::string& params_its::angle                  = std::string("angle");

const std::string& params_its::payload_type = std::string("payload_type");

const std::string& params_its::next_header     = std::string("next_header");
const std::string& params_its::header_type     = std::string("header_type");
const std::string& params_its::header_sub_type = std::string("header_sub_type");

const std::string& params_its::interface_id = std::string("interface_id");

const std::string& params_its::uu_protocol  = std::string("uu_protocol");
const std::string& params_its::uu_transport = std::string("uu_transport");
const std::string& params_its::pc5_layer = std::string("pc5_layer");
const std::string& params_its::mqtt_topics  = std::string("mqtt_topics");
const std::string& params_its::mqtt_protocol  = std::string("mqtt_protocol");
const std::string& params_its::mqtt_client_id  = std::string("mqtt_client_id");
